
;--- Very simple file compare. Public Domain.
;--- Mixed-language application (uses CRT)

;--- Win32 binary:
;--- assemble: jwasm -coff jfc.asm
;--- link:     link /subsystem:console jfc.obj \msvc\lib\libc.lib

;--- Linux binary:
;--- assemble: jwasm -zcw -elf -Fo jfc.o jfc.asm
;--- link:     gcc -o jfc jfc.o

    .386
    .MODEL FLAT, c
    option casemap:none

printf  proto c :ptr BYTE, :VARARG
fopen   proto c :ptr BYTE, :ptr BYTE
fclose  proto c :ptr
fseek   proto c :ptr, :DWORD, :DWORD
ftell   proto c :ptr
fread   proto c :ptr BYTE, :DWORD, :DWORD, :ptr
malloc  proto c :DWORD
free    proto c :ptr

if 1
externdef c errno:dword
else
;--- if errno is to be defined as a function call
__errno macro
__errno_location proto c  ;this is the gcc name
    call __errno_location
    mov eax,[eax]
    exitm <eax>
    endm
errno textequ <__errno()>
endif

SEEK_SET equ 0
SEEK_END equ 2

lf  equ 10

CStr macro text
local xxx
    .const
xxx db text,0
    .code
    exitm <offset xxx>
    endm

    .CODE

main proc c argc:dword, argv:ptr ptr

local file1:dword
local filesize1:dword
local buffer1:dword
local file2:dword
local filesize2:dword
local buffer2:dword
local cnt:dword

    .if ( argc < 3 )
        invoke printf, CStr(<"jfc v1.0, Public Domain.",lf>)
        invoke printf, CStr(<"jfc compares two binary files.",lf>)
        invoke printf, CStr(<"usage: jfc file1 file2",lf>)
        mov eax,1
        ret
    .endif
    mov cnt, 0
    mov ebx,argv
    mov ebx,[ebx+1*4]
    mov file1, ebx
    invoke fopen, ebx, CStr("rb")
    .if ( !eax )
        invoke printf, CStr(<"open error file '%s' [%u]",lf>), ebx, errno
        mov eax,1
        ret
    .endif
    mov ebx, eax
    invoke fseek, ebx, 0, SEEK_END
    invoke ftell, ebx
    mov filesize1, eax
    invoke fseek, ebx, 0, SEEK_SET
    mov eax, filesize1
    invoke malloc, eax
    .if ( eax == 0 ) 
        invoke printf, CStr(<"out of memory",lf>)
        invoke fclose, ebx
        mov eax,1
        ret
    .endif
    mov buffer1, eax
    invoke fread, buffer1, 1, filesize1, ebx
    push eax
    invoke fclose, ebx
    pop eax
    .if ( eax != filesize1 )
        invoke printf, CStr(<"read error file '%s' [%u]",lf>), file1, errno
        mov eax,1
        ret
    .endif

    mov ebx,argv
    mov ebx,[ebx+2*4]
    mov file2, ebx
    invoke fopen, ebx, CStr("rb")
    .if ( !eax )
        invoke printf, CStr(<"open error file '%s' [%u]",lf>), ebx, errno
        mov eax,1
        ret
    .endif
    mov ebx, eax
    invoke fseek, ebx, 0, SEEK_END
    invoke ftell, ebx
    mov filesize2, eax
    invoke fseek, ebx, 0, SEEK_SET
    mov eax, filesize2
    invoke malloc, eax
    .if ( eax == 0 ) 
        invoke printf, CStr(<"out of memory",lf>)
        invoke fclose, ebx
        mov eax,1
        ret
    .endif
    mov buffer2, eax
    invoke fread, buffer2, 1, filesize2, ebx
    push eax
    invoke fclose, ebx
    pop eax
    .if ( eax != filesize2 )
        invoke printf, CStr(<"read error file '%s' [%u]",lf>), file2, errno
        mov eax,1
        ret
    .endif

    mov eax, filesize1
    .if ( eax != filesize2 ) 
        invoke printf, CStr(<"%s, %s: file sizes differ",lf>), file1, file2
        mov eax,1
        ret
    .endif

    mov esi, buffer1
    mov edi, buffer2
    mov ecx, eax
    .while ( ecx )

        repz cmpsb

        setnz al
        movzx eax, al
        add cnt, eax

        .if ( eax )
            push ecx
            mov edx, esi
            dec edx
            sub edx, buffer1
            movzx eax,byte ptr [esi-1]
            movzx ecx,byte ptr [edi-1]
            invoke printf, CStr(<"%08Xh: %02X %02X (%s %s)",lf>), edx, eax, ecx, file1, file2
            pop ecx
        .endif
    .endw

    invoke free, buffer1
    invoke free, buffer2

    mov eax, cnt
    and eax, eax
    setnz al
    movzx eax,al
    ret
    align 4

main endp

    END
